VERSION 5.00
Begin VB.Form TOChatConsole 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Chatroom: Name, Exchange"
   ClientHeight    =   3240
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   6450
   Icon            =   "TOChatConsole.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3240
   ScaleWidth      =   6450
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdIgnore 
      Caption         =   "&Ignore"
      Height          =   465
      Left            =   5640
      TabIndex        =   2
      Top             =   2400
      Width           =   735
   End
   Begin VB.ListBox lstUsers 
      Height          =   2085
      Left            =   4680
      Style           =   1  'Checkbox
      TabIndex        =   4
      Top             =   240
      Width           =   1695
   End
   Begin VB.CheckBox chkFilterHTML 
      Caption         =   "Filter HTML"
      Height          =   195
      Left            =   4680
      TabIndex        =   6
      Top             =   2910
      UseMaskColor    =   -1  'True
      Value           =   1  'Checked
      Width           =   1335
   End
   Begin VB.TextBox txtSend 
      Height          =   735
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Text            =   "TOChatConsole.frx":08CA
      Top             =   2400
      Width           =   4455
   End
   Begin VB.CommandButton cmdChatSend 
      Caption         =   "&Send"
      Default         =   -1  'True
      Height          =   465
      Left            =   4680
      TabIndex        =   1
      Top             =   2400
      Width           =   895
   End
   Begin VB.ListBox lstChat 
      Height          =   2205
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   4455
   End
   Begin VB.Label lblUserCount 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "No users are here."
      Height          =   195
      Left            =   4680
      TabIndex        =   5
      Top             =   0
      Width           =   1305
   End
   Begin VB.Menu mnuContext 
      Caption         =   "Context"
      Visible         =   0   'False
      Begin VB.Menu mnuCopy 
         Caption         =   "&Copy"
      End
      Begin VB.Menu mnuClear 
         Caption         =   "&Clear Window"
      End
   End
End
Attribute VB_Name = "TOChatConsole"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public Screenname As String
Public Roomname As String
Public Exchange As String
Public TotalUsers As Integer

Private Static Sub cmdChatsend_Click()
Dim i As Integer
For i = 1 To TOClone.tocSock.Count
  If TOClone.tocSock(i).Screenname = Screenname Then
    TOClone.tocSock(i).InChatRoomSend TOClone.tocSock.Item(i).InChatRoomNameToIndex(Roomname), txtSend.Text
    txtSend.Text = vbNullString
    Exit Sub
  End If
Next i
txtSend.Text = vbNullString
End Sub

Private Sub cmdIgnore_Click()
If lstUsers.ListIndex < 0 Then Exit Sub
lstUsers.Selected(lstUsers.ListIndex) = Not lstUsers.Selected(lstUsers.ListIndex)
End Sub

Private Sub Form_Load()
Me.Caption = "Chatroom For " & Screenname & ": " & Roomname & ", " & Exchange
Me.Show
ChatString vbNullString, "You have just entered room " & Roomname & ", exchange " & Exchange & "."
End Sub

Private Sub Form_Unload(Cancel As Integer)
Static alreadycalled As Boolean
If alreadycalled = True Then Exit Sub

alreadycalled = True
Dim i As Integer
For i = 1 To TOClone.tocSock.Count
  If TOClone.tocSock(i).Screenname = Screenname Then
    TOClone.tocSock(i).ConsoleClose Roomname
    Exit Sub
  End If
Next i
alreadycalled = False
End Sub

Public Static Sub ChatString(ByRef User As String, ByRef Text As String)
Dim tracking As Boolean: tracking = False

If lstChat.ListIndex = lstChat.ListCount - 1 Then tracking = True
If User = vbNullString Then
  If chkFilterHTML Then
    lstChat.AddItem KillAimtml(Text)
  Else
    lstChat.AddItem Text
  End If
Else
  If Ignored(User) Then Exit Sub
  If chkFilterHTML Then
    lstChat.AddItem User & ": " & vbTab & KillAimtml(Text)
  Else
    lstChat.AddItem User & ": " & vbTab & Text
  End If
End If

If lstChat.ListCount > 100 Then lstChat.RemoveItem 1
If tracking = True Then lstChat.ListIndex = lstChat.ListCount - 1
End Sub
 
Public Static Sub ChatUser(ByRef Inside As Boolean, ByRef SNList As String)
Dim strList() As String
Dim i As Integer

strList = Split(SNList, ":")
If Inside Then
  TotalUsers = TotalUsers + (UBound(strList, 1) + 1)
  For i = 0 To UBound(strList, 1)
    lstUsers.AddItem strList(i)
    If UBound(strList) < 1 Then
      ChatString vbNullString, strList(i) & " has entered the room."
    End If
  Next i
Else
  TotalUsers = TotalUsers - (UBound(strList, 1) + 1)
  For i = 0 To UBound(strList, 1)
    DestroyListItem lstUsers, strList(i)
    ChatString vbNullString, strList(i) & " has left the room."
  Next i
End If

If TotalUsers <> 1 Then
lblUserCount.Caption = TotalUsers & " people here."
ElseIf TotalUsers = 0 Then
lblUserCount.Caption = "No users are here."
Else
lblUserCount.Caption = TotalUsers & " person here."
End If
End Sub

Private Static Sub lstChat_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = vbRightButton Then
  PopupMenu mnuContext
End If
End Sub

Private Static Sub mnuClear_Click()
lstChat.Clear
End Sub

Private Static Sub mnuCopy_Click()
If lstChat.ListIndex < 0 Then Exit Sub
Clipboard.Clear
Clipboard.SetText lstChat.List(lstChat.ListIndex)
End Sub

Public Static Function Ignored(strUser As String) As Boolean
Dim i As Integer
For i = 0 To lstUsers.ListCount - 1
  If Replace(LCase(lstUsers.List(i)), " ", "") = Replace(LCase(strUser), " ", "") Then
    If lstUsers.Selected(i) = True Then Ignored = True Else Ignored = False
    Exit Function
  End If
Next i
End Function
